#pragma once

//----------------------------------------------------------------------
//
//			File:			"viCursor.h"
//			Created:		24-Feb-2011
//			Author:			Nobuhide Tsuda
//			Description:	viJ[\ړ֐錾
//
//----------------------------------------------------------------------

/*

	Copyright (C) 2011 by Nobuhide Tsuda

	{\[XR[h͊{I MIT CZXɏ]B
	http://www.opensource.org/licenses/mit-license.php
	http://sourceforge.jp/projects/opensource/wiki/licenses%2FMIT_license

	A͕sRŎg̈ GPL 匙Ȃ̂ŁA
	GPL CZXvWFNg{\[X𗬗p邱Ƃւ

*/

#include	<QTextCursor>
#include	"textCursor.h"

namespace ViMoveOperation {
	enum {
		Left = 100,				//	h
		Down,					//	j
		Up,						//	k
		Right,					//	l
		RightForA,				//	a
		FirstNonBlankChar,		//	^
		LastChar,				//	$
		NextWord,				//	w
		NextWordEnd,			//	e
		PrevWord,				//	b
		NextSSWord,				//	W
		NextSSWordEnd,			//	E
		PrevSSWord,				//	B
		NextLine,				//	+ Enter
		PrevLine,				//	-
		TopOfView,				//	H
		MiddleOfView,			//	M
		BottomOfView,			//	L
		MatchParen,				//	%
		NextBlankLine,			//	}
		PrevBlankLine,			//	{
		NextBeginBlock,			//	]]
		PrevBeginBlock,			//	[[
		JumpLine,				//	nG
		LastLine,				//	G
	};
}
enum {
	CT_EOF = 0,
	CT_NEWLINE,
	CT_SPACE,
	CT_ALNUM,		//	pp
	CT_HANKANA,		//	pJi
	CT_SYM,			//	pV{
	//CT_DBSPACE,		//	Sp
	CT_HIRA,		//	SpЂ炪
	CT_KANA,		//	SpJ^Ji
	CT_DBALNUM,		//	Spp
	CT_KANJI,		//	
	//CT_SYM,			//	SpL
	CT_CONT,		//	JԂLiXȂǁj
	CT_GREEK,		//	MV
	CT_ALPHA_EX,	//	̑̍̕
	CT_OTHER,		//	̑
};
uchar getCharType(QChar);
bool moveCursor(ViewCursor &cur, /*int &x,*/ int mv, int n=1, bool=false, const ViewBlock *block=0);
bool moveCursorFindInLine(DocCursor &cur, ushort, const QChar &, int n=1);
bool moveCursorFind(DocCursor &cur, const QRegExp &, bool forward, int n=1, bool loop=true);
bool moveCursorFind(ViewCursor &cur, const QRegExp &, bool forward, int n=1, bool loop=true);

typedef uchar MoveMode;

#if 0
class ViCursor : public ViewCursor
{
public:
	ViCursor();
	ViCursor(const ViCursor &);
	ViCursor(const ViewCursor &, int = 0);

public:
	int		nthLine() const { return m_nthLine; }
	int		calcNthLine();

public:
	//bool	movePosition(MoveOperation operation, MoveMode mode, int = 1);
	bool	movePosition(int mv, MoveMode mode = MoveAnchor, int n=1, bool=false, const QTextBlock *block=0);
	void	moveLeftIfEndOfLine();
	void	moveXAtNthLine(const QTextBlock &);

private:
	int		m_nthLine;		//	Block ̉sڂH for j k 
};
#endif
